#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <xosd.h>
#include <string.h>

using namespace std;

extern "C" {

xosd* Create(int numLines = 1) {
	xosd* osd;
	osd = xosd_create (numLines);
	if (osd == NULL) {
		 return NULL;
	}
	return osd;
}

int SetFont(xosd* osd, char text[]) {
	return xosd_set_font (osd, text);
}

int SetShadowOffset(xosd* osd, int shadow) {
	return xosd_set_shadow_offset (osd, shadow);
}

int SetColour( xosd* osd, char text[] ) {
	return xosd_set_colour (osd, text);
}	

int SetOutlineOffset( xosd* osd, int offset) {
	return xosd_set_outline_offset(osd, offset);
}

int SetOutlineColour( xosd* osd, char text[]) {
	return xosd_set_outline_colour(osd, text);
}


int SetPos( xosd* osd, int location) {
	switch (location) {
		case 1:
				return xosd_set_pos (osd, XOSD_top);
		case 2:
				return xosd_set_pos (osd, XOSD_middle);
		case 3:
				return xosd_set_pos (osd, XOSD_bottom);
		default:
				return -1;
	}
}

int SetAlign( xosd* osd, int location) {
	switch (location) {
		case 1:
				return xosd_set_align (osd, XOSD_left);
		case 2:
				return xosd_set_align (osd, XOSD_center);
		case 3:
				return xosd_set_align (osd, XOSD_right);
		default:
				return -1;
	}
}


int Show(xosd* osd) {
	return xosd_show (osd);
}

int Hide(xosd* osd) {
	return xosd_hide (osd);
}

int SetHorizontalOffset( xosd* osd, int offset) {
	return xosd_set_horizontal_offset (osd, offset);
}
	
int SetVerticalOffset( xosd* osd, int offset) {
	return xosd_set_vertical_offset (osd, offset);
}

int DisplayPercentage(xosd* osd, int line, int percent) {
	return xosd_display (osd, line, XOSD_percentage, percent );
}

int DisplaySlider(xosd* osd, int line, int slide) {
	return xosd_display (osd, line, XOSD_slider, slide );
}

int Display(xosd* osd, int line, char text[]) {
	return xosd_display (osd, line, XOSD_string, text );
}

int Scroll(xosd* osd, int amount) {
	return xosd_scroll (osd, amount);
}

int Destroy(xosd* osd) {
	return xosd_destroy (osd);
}

int SetTimeout( xosd* osd, int value ) {	
	return xosd_set_timeout(osd, value);
}

int WaitUntilNoDisplay( xosd* osd ) {	
	return xosd_wait_until_no_display(osd);
}

void Error( char* msg ) {
  strcpy( msg, xosd_error );
}

} // End extern
