include xosd.e --Necesary for xosd routines and constants
include std/os.e

-- Create osd reference with a 1 line display
atom osd = xosdCreate(7)

-- Pick a font type and size
sequence font = "-adobe-helvetica-bold-r-normal-*-*-240-*-*-p-*-iso8859-1"
xosdSetFont(osd,font)

-- Set a shadow offset
xosdSetShadowOffset(osd,1)

-- Set the text color to red
xosdSetColour(osd,"red")

-- Set the outline offset to 1
xosdSetOutlineOffset(osd, 1)

-- Set the outline color to black
xosdSetOutlineColour(osd,"black")

-- Set vertical position to the middle
xosdSetPosition(osd,xosd_middle)
xosdSetVerticalOffset(osd, 10)

-- Set horizontal position to the center with an offset
xosdSetAlign(osd,xosd_center)
xosdSetHorizontalOffset(osd, 75)

-- Display text on lines 0 and 1
xosdDisplay(osd,0,"Euphoria is writing")
xosdDisplay(osd,1,"on your screen!")

-- Hide and show the display
sleep(2)
xosdHide(osd)
sleep(1)
xosdShow(osd)
sleep(1)
xosdHide(osd)

-- Display a percentage bar that counts down on line 4
-- Display a slider that moves down on line 7
xosdSetHorizontalOffset(osd, 25)
xosdSetColour(osd,"blue")
xosdDisplay(osd,0,"")
xosdDisplay(osd,1,"Percentage and slider...")
for i = 0 to 10 do
	xosdDisplayPercentage(osd,3,100-i*10)
	xosdDisplaySlider(osd,6,i*10)
	sleep(0.5)
end for

-- Set the display to timeout after 5 seconds
xosdSetTimeout(osd, 5)

-- Blank out other display lines
xosdDisplay(osd,1,"")
xosdDisplay(osd,3,"")
xosdDisplay(osd,6,"")

xosdDisplay(osd,0,"Goodbye...")

-- Block execution until display is hidden
xosdWaitUntilNoDisplay(osd)

-- Check error messages by writing to invalid number
if xosdDisplay(osd,100,"") = -1 then
	printf(1,"Error Msg Test -> %s \n", {xosdError()} )
end if

-- Destroy osd
xosdDestroy(osd) 
